Contact Form

Bootstrap contact form

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

Today we will learn how to easily create beautiful contact forms using the Bootstrap framework, PHP and JavaScript. You don't need specialist knowledge to achieve this, just follow this tutorial. If you have any questions, please do not hesitate to post a question on our support forum.

What will I learn?

  1. How to create an HTML contact form using Bootstrap
  2. How to connect a contact form to your email using PHP
  3. How to validate entered fields using JavaScript and PHP
  4. How to send a contact form without reloading the page using AJAX
  5. How to create an anti-spam mechanism
  6. How to use different inputs

At the end of this tutorial I will also show you few different contact form styles as an inspiration and ready to use snippets. If you don't want to follow the tutorial or you, just need a working solution, you can download the final files from our GitHub repository here.


Bootstrap Contact Form

An example contact form is given below:

Contact us

Do you have any questions? Please do not hesitate to contact us directly. Our team will come back to you within a matter of hours to help you.

  • San Francisco, CA 94126, USA

  • + 01 234 567 89

  • contact@mdbootstrap.com

        
            

          <!--Section: Contact v.2-->
          <section class="mb-4">

              <!--Section heading-->
              <h2 class="h1-responsive font-weight-bold text-center my-4">Contact us</h2>
              <!--Section description-->
              <p class="text-center w-responsive mx-auto mb-5">Do you have any questions? Please do not hesitate to contact us directly. Our team will come back to you within
                  a matter of hours to help you.</p>

              <div class="row">

                  <!--Grid column-->
                  <div class="col-md-9 mb-md-0 mb-5">
                      <form id="contact-form" name="contact-form" action="mail.php" method="POST">

                          <!--Grid row-->
                          <div class="row">

                              <!--Grid column-->
                              <div class="col-md-6">
                                  <div class="md-form mb-0">
                                      <input type="text" id="name" name="name" class="form-control">
                                      <label for="name" class="">Your name</label>
                                  </div>
                              </div>
                              <!--Grid column-->

                              <!--Grid column-->
                              <div class="col-md-6">
                                  <div class="md-form mb-0">
                                      <input type="text" id="email" name="email" class="form-control">
                                      <label for="email" class="">Your email</label>
                                  </div>
                              </div>
                              <!--Grid column-->

                          </div>
                          <!--Grid row-->

                          <!--Grid row-->
                          <div class="row">
                              <div class="col-md-12">
                                  <div class="md-form mb-0">
                                      <input type="text" id="subject" name="subject" class="form-control">
                                      <label for="subject" class="">Subject</label>
                                  </div>
                              </div>
                          </div>
                          <!--Grid row-->

                          <!--Grid row-->
                          <div class="row">

                              <!--Grid column-->
                              <div class="col-md-12">

                                  <div class="md-form">
                                      <textarea type="text" id="message" name="message" rows="2" class="form-control md-textarea"></textarea>
                                      <label for="message">Your message</label>
                                  </div>

                              </div>
                          </div>
                          <!--Grid row-->

                      </form>

                      <div class="text-center text-md-left">
                          <a class="btn btn-primary" onclick="document.getElementById('contact-form').submit();">Send</a>
                      </div>
                      <div class="status"></div>
                  </div>
                  <!--Grid column-->

                  <!--Grid column-->
                  <div class="col-md-3 text-center">
                      <ul class="list-unstyled mb-0">
                          <li><i class="fas fa-map-marker-alt fa-2x"></i>
                              <p>San Francisco, CA 94126, USA</p>
                          </li>

                          <li><i class="fas fa-phone mt-4 fa-2x"></i>
                              <p>+ 01 234 567 89</p>
                          </li>

                          <li><i class="fas fa-envelope mt-4 fa-2x"></i>
                              <p>contact@mdbootstrap.com</p>
                          </li>
                      </ul>
                  </div>
                  <!--Grid column-->

              </div>

          </section>
          <!--Section: Contact v.2-->

        
        
    

Copy and paste the following code into your file (i.e. index.html):

Note!

Within this tutorial we are using the Material Design for Bootstrap library, you can download it for free from here. Without the library the form will still work, however it may look and behave differently. It's recommended to use this library along with the tutorial.


Connecting your contact form to email using PHP

Create a new file called mail.php within the same folder as the contact form and place within it the following code:

        
            

            <?php
              if(isset( $_POST['name']))
              $name = $_POST['name'];
              if(isset( $_POST['email']))
              $email = $_POST['email'];
              if(isset( $_POST['message']))
              $message = $_POST['message'];
              if(isset( $_POST['subject']))
              $subject = $_POST['subject'];

              $content="From: $name \n Email: $email \n Message: $message";
              $recipient = "youremail@here.com";
              $mailheader = "From: $email \r\n";
              mail($recipient, $subject, $content, $mailheader) or die("Error!");
              echo "Email sent!";
            ?>

        
        
    

Now just replace youremail@here.com with your email address and it's done. Remember that in order for the script to work you will need to keep it on PHP-supporting server such as Apache.

You can download the source code file from here.


Javascript validation (client-side validation)

Our form now works fine. However currently if the user makes a mistake by clicking send without filling in the form first, this will result in sending an empty email. The other potential problem is that user might make a mistake in his email address so he would never get a response from us.

In order to apply validation we have to change the code of our form. So first change the existing line in index.html file

        
            

          <a class="btn btn-primary" onclick="document.getElementById('contact-form').submit();">Send</a>

        
        
    

with the following line, which instead of directly submitting the form will call our validation function:

        
            

          <a class="btn btn-primary" onclick="validateForm();">Send</a>

        
        
    

Now we have to create our validation function. Add the following code after (below) the script has finished importing the bootstrap JavaScript files:

        
            

          function validateForm() {
            var name =  document.getElementById('name').value;
            if (name == "") {
                document.querySelector('.status').innerHTML = "Name cannot be empty";
                return false;
            }
            var email =  document.getElementById('email').value;
            if (email == "") {
                document.querySelector('.status').innerHTML = "Email cannot be empty";
                return false;
            } else {
                var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                if(!re.test(email)){
                    document.querySelector('.status').innerHTML = "Email format invalid";
                    return false;
                }
            }
            var subject =  document.getElementById('subject').value;
            if (subject == "") {
                document.querySelector('.status').innerHTML = "Subject cannot be empty";
                return false;
            }
            var message =  document.getElementById('message').value;
            if (message == "") {
                document.querySelector('.status').innerHTML = "Message cannot be empty";
                return false;
            }
            document.querySelector('.status').innerHTML = "Sending...";
          }

        
        
    

You can download the source file from here.


PHP validation (server-side validation)

Since user can easily disable Javascript on his side, it's very important to also validate the submitted form on the server side. In order to add similar validation as we did in the previous point, update the mail.php file by adding the following code:

        
            


<? php
  if (isset($_POST['name']))
    $name = $_POST['name'];
  if (isset($_POST['email']))
    $email = $_POST['email'];
  if (isset($_POST['message']))
    $message = $_POST['message'];
  if (isset($_POST['subject']))
    $subject = $_POST['subject'];
  if ($name === '') {
    echo "Name cannot be empty.";
    die();
  }
  if ($email === '') {
    echo "Email cannot be empty.";
    die();
  } else {
    if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
      echo "Email format invalid.";
      die();
    }
  }
  if ($subject === '') {
    echo "Subject cannot be empty.";
    die();
  }
  if ($message === '') {
    echo "Message cannot be empty.";
    die();
  }
  $content = "From: $name \nEmail: $email \nMessage: $message";
  $recipient = "youremail@here.com";
  $mailheader = "From: $email \r\n";
  mail($recipient, $subject, $content, $mailheader) or die("Error!");
  echo "Email sent!";
?>

        
        
    

You can download source file from here.


Sending an email without reloading the page using AJAX

Our contact form is working correctly, however the user experience leaves much to be desired. Instead of reloading the page, we would like to send contact form on the same page. Let’s replace following JavaScript code in index.html file:

        
            

  document.getElementById('status').innerHTML = "Sending...";
  formData = {
    'name': $('input[name=name]').val(),
    'email': $('input[name=email]').val(),
    'subject': $('input[name=subject]').val(),
    'message': $('textarea[name=message]').val()
  };


  $.ajax({
    url: "mail.php",
    type: "POST",
    data: formData,
    success: function (data, textStatus, jqXHR) {

      $('#status').text(data.message);
      if (data.code) //If mail was sent successfully, reset the form.
        $('#contact-form').closest('form').find("input[type=text], textarea").val("");
    },
    error: function (jqXHR, textStatus, errorThrown) {
      $('#status').text(jqXHR);
    }
  });

        
        
    

We also need to adjust our PHP code. Instead of sending a simple string with the message, we will send a slightly more complex object which will contain both status and the message. If everything goes fine and the email was successfully sent. We will return status 1 and clean our form to make sure that user does not send it multiple times. In case of validation errors we will return 0 and keep the data within the form.

        
            

<? php
  $name = $_POST['name'];
  $email = $_POST['email'];
  $message = $_POST['message'];
  $subject = $_POST['subject'];
  header('Content-Type: application/json');
  if ($name === '') {
    print json_encode(array('message' => 'Name cannot be empty', 'code' => 0));
    exit();
  }
  if ($email === '') {
    print json_encode(array('message' => 'Email cannot be empty', 'code' => 0));
    exit();
  } else {
    if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
      print json_encode(array('message' => 'Email format invalid.', 'code' => 0));
      exit();
    }
  }
  if ($subject === '') {
    print json_encode(array('message' => 'Subject cannot be empty', 'code' => 0));
    exit();
  }
  if ($message === '') {
    print json_encode(array('message' => 'Message cannot be empty', 'code' => 0));
    exit();
  }
  $content = "From: $name \nEmail: $email \nMessage: $message";
  $recipient = "youremail@here.com";
  $mailheader = "From: $email \r\n";
  mail($recipient, $subject, $content, $mailheader) or die("Error!");
  print json_encode(array('message' => 'Email successfully sent!', 'code' => 1));
  exit();
?>


        
        
    

Voila! Now our contact form works without reloading.

You can download the source file from here.


Anti-spam

Once you create your contact form it's worth adding an anti spam mechanism. Unfortunately, there are hundreds of thousands of spambots browsing the Internet every second looking for unsecured forms and submitting them. How they work? They simply fill typical inputs like name or email and automatically submit the form. In the best case you will get occasional frustrating spam messages. In worst they can bring down your website by submitting the contact form hundreds of times a second.

The simplest (but also the weakest) way to secure a contact form is to add a custom field, then ask the customer to fill it in a certain way, and submit the form only if the entered value is correct. Real humans will easily perform this task, but bots most probably won't be able to pass the check.

Other questions

  • Q: How many eyes does a typical person have? (ex: 1) A: 2
  • Q: How many legs on a typical dog? (ex: 5) A: 4
  • Q: How many units in a dozen? (ex: 11) A: 12
  • Q: Name of the actor Di Caprio? (ex: Rafaelo) A:Leonardo
  • Q: How many days in a week? (ex: 8) A: 7
  • Q: How many days in July? (ex: 28) A: 31

If you want a more sophisticated solution read about Google's reCAPTCHA service


Other inputs

We've already used text inputs as well as the text area for larger pieces of text but there are yet more useful input types we can use to enhance our contact form.

Checkbox

HTML code:

        
            

          <div class="form-check">
            <input type="checkbox" class="form-check-input" name="updates" id="updates" value="1">
            <label for="updates" class="form-check-label">Notify me about new updates</label>
          </div>

        
        
    

JS code:

        
            

          formData = {
            'name'     : $('input[name=name]').val(),
            'email'    : $('input[name=email]').val(),
            'subject'  : $('input[name=subject]').val(),
            'message'  : $('textarea[name=message]').val(),
            'updates'  : $('input:checkbox[name=updates]').is(':checked')
          };

        
        
    

PHP code:

        
            

          if(isset( $_POST['updates']))
          $updates = $_POST['updates'];

        
        
    

Multiple checkboxes

How did you get to know about us?

HTML code:

        
            

          <div id="feedback">
              <h5><strong>How did you get to know about us?</strong></h5>
              <div class="form-check">
                  <input type="checkbox" class="form-check-input" name="channel[]" id="checkbox1" value="nl">
                  <label for="checkbox1" class="form-check-label">Newsletter</label>
              </div>

              <div class="form-check">
                  <input type="checkbox" class="form-check-input" name="channel[]" id="checkbox2" value="ad">
                  <label for="checkbox2" class="form-check-label">Advertisement</label>
              </div>

              <div class="form-check">
                  <input type="checkbox" class="form-check-input" name="channel[]" id="checkbox3" value="ot">
                  <label for="checkbox3" class="form-check-label">Other</label>
              </div>
          </div>

        
        
    

JS code:

        
            

          var channels = [];
          $('#feedback input:checked').each(function() {
            channels.push(this.value);
          });

          formData = {
            'name'     : $('input[name=name]').val(),
            'email'    : $('input[name=email]').val(),
            'subject'  : $('input[name=subject]').val(),
            'message'  : $('textarea[name=message]').val(),
            'channel'  : channels
          };

        
        
    

PHP code:

        
            

          if(isset( $_POST['updates'])){
            foreach ($_POST['channel'] as $value) {
              //loop through all checked checkboxes and do logic
            }
          }

        
        
    

Radio/option buttons

What is your preferred contact method?

HTML code:

        
            

            <div class="form-check mb-3">
                <input class="form-check-input" type="radio" id="radio1" name="cmethod" value="phone" checked>
                <label class="form-check-label" for="radio1">Phone</label>
            </div>

            <div class="form-check mb-3">
                <input class="form-check-input" type="radio" id="radio2" name="cmethod" value="mail">
                <label class="form-check-label" for="radio2">Email</label>
            </div>

            <div class="form-check mb-3">
                <input class="form-check-input" type="radio" id="radio3" name="cmethod" value="post">
                <label class="form-check-label" for="radio3">Post</label>
            </div>

        
        
    

JS code:

        
            

          formData = {
            'name'     : $('input[name=name]').val(),
            'email'    : $('input[name=email]').val(),
            'subject'  : $('input[name=subject]').val(),
            'message'  : $('textarea[name=message]').val(),
            'cmethod'  : $('input:radio[name=cmethod]:checked').val()
          };

        
        
    

PHP code:

        
            

            if(isset( $_POST['cmethod']))
            $updates = $_POST['cmethod'];

        
        
    

Other contact form samples

CONTACT US

Contact Us

You can find more examples of Contact Forms in the links below:

Form components Contact sections

Contact Form

MDB Vue + Laravel

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Following this tutorial requires you to complete all steps from Quick start - Laravel - we will be picking up exactly where this instruction left off.
I assume that you successfully installed composer and created simple Laravel project using mdbvue preset.

Tutorial in steps:

  1. Preparation to development
  2. Creating MDB Form
  3. Submitting form with axios
  4. Creating a controller
  5. Adding a new route
  6. Setting environment variables
  7. Sending a form

Preparation for development

1. Starting a server

If you haven't done that already, start the development server with the following command:

php artisan serve

By default server will start on port 8000, so in your browser go to http://localhost:8000/.

In separate command line window run npm run watch-poll - this way all your files will be updated immediately after reloading the page.


2. CSRF Token

Now you should see the demo page rendered on your screen. In a browser console you might've noticed the following warning:

CSRF token not found: https://laravel.com/docs/csrf#csrf-x-csrf-token

In general, Laravel generates a CSRF (cross-site request forgery) token for each active user session and use it to verify a request’s origin. Token can be stored in a meta tag in HTML document. Open resources/views/welcome.blade.php directory and add the following line between head tags:

<meta name="csrf-token" content="{{ csrf_token() }}">

        
            
          <!DOCTYPE html>
          <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

          <head>
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <meta name="csrf-token" content="{{ csrf_token() }}">
            <title>Laravel</title>
          </head>

          <body>
            <div id="app">
              <example-component />
            </div>
            <script type="text/javascript" src="js/app.js"></script>
          </body>

          </html>
        
        
    

Creating MDB Vue Form

An example contact form is given below:

Contact us

Do you have any questions? Please do not hesitate to contact us directly. Our team will get back to you within a matter of hours to help you.

  • San Francisco, CA 94126, USA

  • + 01 234 567 89

  • contact@mdbootstrap.com

Copy and paste the following code into your file in resources/js/components directory (i.e. ExampleComponent.vue):

        
            
      <template>
        <mdb-container class="mt-5">
          <mdb-card>
            <mdb-card-title class="mt-4 h2">Contact us</mdb-card-title>
            <mdb-card-body>
              <mdb-card-text class="pr-5 pl-5" mr-4 ml-4>Do you have any questions? Please do not hesitate to contact us
                directly. Our team will cgetback to you within a matter of hours to help you.</mdb-card-text>
              <form class="needs-validation" novalidate @submit.prevent="submitForm">
                <mdb-row>
                  <mdb-col md="8">
                    <mdb-row>
                      <mdb-col>
                        <mdb-input label="Your name" v-model="fields.name" required />
                      </mdb-col>
                      <mdb-col>
                        <mdb-input type="email" label="Your email" v-model="fields.email" required />
                      </mdb-col>
                    </mdb-row>
                    <mdb-row>
                      <mdb-col>
                        <mdb-input label="Subject" v-model="fields.subject" required />
                      </mdb-col>
                    </mdb-row>
                    <mdb-row>
                      <mdb-col>
                        <mdb-input type="textarea" label="Your message" v-model="fields.message" required />
                      </mdb-col>
                    </mdb-row>
                  </mdb-col>
                  <mdb-col md="4">
                    <mdb-row>
                      <mdb-col class="mt-4">
                        <mdb-icon icon="map-marker-alt" size="2x" />
                        <p>San Francisco, CA 94126, USA</p>
                      </mdb-col>
                    </mdb-row>
                    <mdb-row>
                      <mdb-col class="mt-4">
                        <mdb-icon icon="phone" size="2x" />
                        <p>+ 01 234 567 89</p>
                      </mdb-col>
                    </mdb-row>
                    <mdb-row>
                      <mdb-col class="mt-4">
                        <mdb-icon icon="envelope" size="2x" />
                        <p>contact@mdbootstrap.com</p>
                      </mdb-col>
                    </mdb-row>
                  </mdb-col>
                </mdb-row>
                <mdb-btn color="primary" type="submit" class="float-left">Send</mdb-btn>
              </form>
            </mdb-card-body>
          </mdb-card>
        </mdb-container>
      </template>
      
        
    
        
            
      <script>
        import {
          mdbContainer,
          mdbInput,
          mdbCard,
          mdbCardHeader,
          mdbCardTitle,
          mdbCardText,
          mdbCardBody,
          mdbIcon,
          mdbBtn,
          mdbRow,
          mdbCol
        } from "mdbvue";
        export default {
          components: {
            mdbContainer,
            mdbInput,
            mdbCard,
            mdbCardHeader,
            mdbCardTitle,
            mdbCardBody,
            mdbCardText,
            mdbIcon,
            mdbBtn,
            mdbRow,
            mdbCol
          },
          data() {
            return {
              fields: {
                name: "",
                email: "",
                subject: "",
                message: ""
              }
            };
          },
          methods: {
            submitForm(event) {
              event.target.classList.add("was-validated");
              // submit form
            }
          }
        };
      </script>
      
        
    
        
            
      <style scoped>
        .container {
          text-align: center;
        }
      </style>
      
        
    

Submit form with axios

axios is included in Laravel App by default, so installation is unnecessary - just import axios directly to your component file.

        
            
      <script>
        import axios from "axios";
      </script>
      
        
    

Next step is to create validate() method preventing user from submitting an incomplete form. Once it is done we will be using axios to send our form to a /submit route.

        
            
      <script>
        import axios from "axios";
        import {
          mdbContainer,
          mdbInput,
          mdbCard,
          mdbCardHeader,
          mdbCardTitle,
          mdbCardText,
          mdbCardBody,
          mdbIcon,
          mdbBtn,
          mdbRow,
          mdbCol
        } from "mdbvue";
        export default {
          components: {
            mdbContainer,
            mdbInput,
            mdbCard,
            mdbCardHeader,
            mdbCardTitle,
            mdbCardBody,
            mdbCardText,
            mdbIcon,
            mdbBtn,
            mdbRow,
            mdbCol
          },
          data() {
            return {
              fields: {
                name: "",
                email: "",
                subject: "",
                message: ""
              }
            };
          },
          methods: {
            validate() {
              const form = [...arguments];
              const emailRegexp = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
              for (let index in form) {
                let field = form[index];
                if (field === "email" && !emailRegexp.test(this.fields[field])) {
                  return false;
                } else if (this.fields[field] === "") {
                  return false;
                }
              }
              return true;
            },
            submitForm(event) {
              event.target.classList.add("was-validated");
              if (this.validate("email", "name", "message", "subject")) {
                axios
                  .post("/submit", this.fields)
                  .then(response => {
                    alert("Message sent!");
                    this.fields = {};
                    event.target.classList.remove("was-validated");
                  })
                  .catch(error => {
                    console.log(error);
                  });
              }
            }
          }
        };
      </script>
      
        
    

Once the message is successfully sent, we will alert the user and clear the form's inputs with this.fields = {}; line.


Create a Controller

In your command line run following command:

php artisan make:controller FormController

This will create a FormController.php file in app/Http/Controllers directory.

In the FormController class create public submit function and validate data from a request as shown below:

        
            
        <?php
          namespace App\Http\Controllers;
  
          use Illuminate\Http\Request;
  
          class FormController extends Controller
          {
            public function submit(Request $request) {
              $this->validate($request, [
                'name' => 'required|string',
                'email' => 'required|email',
                'message' => 'required',
                'subject' => 'required'
              ]);
              /*
                Mail functionality
  
              */
              return response()->json(null, 200);
            }
          }
      
        
        
    

Add a Route

To run a submit function from FormController on post request to /submit, we need to define a new route in the routes/web.php file:

        
            
          <?php
          /*
          |--------------------------------------------------------------------------
          | Web Routes
          |--------------------------------------------------------------------------
          |
          | Here is where you can register web routes for your application. These
          | routes are loaded by the RouteServiceProvider within a group which
          | contains the "web" middleware group. Now create something great!
          |
          */
          Route::get('/', function () {
            return view('welcome');
          });
          Route::post('/submit', 'FormController@submit');
    
        
        
    

Set environment variables

Laravel uses SwiftMailer library for sending emails - if you're interested in exploring more options, see offical documentation. To get started with sending emails, you need to connect the Laravel App with your Gmail account. Open .env file and set the following environment variables:

        
            
                MAIL_DRIVER =smtp
                MAIL_HOST =smtp.gmail.com
                MAIL_PORT =587
                MAIL_USERNAME=YOUR_GMAIL_USERNAME
                MAIL_PASSWORD=YOUR_GMAIL_PASSWORD
                MAIL_ENCRYPTION=tls
            
        
    

Note!

By default Gmail will block all attempts to send emails from unsafe apps - solving this issue requires opening Gmail settings and allowing access for less safe applications.


Sending email

Let's go back to our FormController.php file and complete the last step - defining email-sending functionality.

        
            
        <?php
          namespace App\Http\Controllers;
          use Illuminate\Http\Request;
          use Mail;
          use App\Http\Requests;
          use App\Http\Controllers\Controller;
          class FormController extends Controller
          {
            public function submit(Request $request) {
              $this->validate($request, [
                  'name' => 'required|string',
                  'email' => 'required|email',
                  'message' => 'required',
                  'subject' => 'required'
              ]);
              $name=$request['name'];
              $email=$request['email'];
              $title=$request['subject'];
              $message=$request['message'];
              $data = array('name'=>"Virat Gandhi");
    
              Mail::raw($message, function($message) use ($title, $name, $email){
                  $message->to(YOUR_EMAIL, YOUR_NAME)->subject
                      ($title);
                  $message->from($email, $name);
              });
              echo "Your email has been send!";
              return response()->json(null, 200);
            }
          }
        
        
    

In code above replace YOUR_EMAIL and YOUR_NAME with your data.

Now you can go back to your application and try sending an email. Explore and modify the form and logic according to your needs.

Happy coding!

Angular Bootstrap Contact Form

Angular Contact Form - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

This Angular Bootstrap Contact Form tutorials is a step-by-step guide on how to create a contact form for sending messages using the NodeJS environment and Express server. It also covers the validation of client-side and server-side messages.

Requirements:

  • Angular 6 with Angular CLI,
  • The NodeJS environment,
  • The Express package from the npm repository,
  • The nodemailer package from the npm repository,
  • The body-parser package from the npm repository.

If you need some ready-to-download code, you will find it here.


Creating the application and the necessary service

Let's start from scratch! Let's create a new application and generate a service responsible for contact with our NodeJS server. In order to do this, execute the commands below in your application terminal:

1. Create a new Angular application using Angular CLI:

        
            
          ng new mdb-contact-form --style=scss
        
        
    

Create a new Connection Service:

        
            
          ng generate service connection
        
        
    

Then add the newly generated ConnectionService to the providers array in the app.module.ts file.


Note!

Within this tutorial we are using the Material Design for Bootstrap library, you can download it for free from here. Without the library, the form will still work — however it may look and behave differently. It's recommended to use this library along with the tutorial.

Creating the form

If you are using the MDB Angular Free version, use the code for the first form. If you are using MDB Angular Pro, copy the second forms code into your application.

Default form contact

Contact us

        
            
                <!-- Default form contact -->
                <form class="text-center border border-light p-5" [formGroup]="contactForm" (ngSubmit)="onSubmit()">
                  <p class="h4 mb-4">Contact us</p>
                  <!-- Name -->
                  <input type="text" formControlName="contactFormName" id="defaultContactFormName" mdbInput
                    class="form-control mb-4" placeholder="Name">
                  <!-- Email -->
                  <input type="email" formControlName="contactFormEmail" id="defaultContactFormEmail" mdbInput
                    class="form-control mb-4" placeholder="E-mail">
                  <!-- Subject -->
                  <label>Subject</label>
                  <select formControlName="contactFormSubjects" class="browser-default custom-select mb-4">
                    <option value="" disabled>Choose option</option>
                    <option value="1" selected>Feedback</option>
                    <option value="2">Report a bug</option>
                    <option value="3">Feature request</option>
                    <option value="4">Feature request</option>
                  </select>
                  <!-- Message -->
                  <div class="form-group">
                    <textarea formControlName="contactFormMessage" class="form-control rounded-0" mdbInput id="exampleFormControlTextarea2"
                      rows="3" placeholder="Message"></textarea>
                  </div>
                  <!-- Copy -->
                  <mdb-checkbox [default]="true" class="mb-4">Send me a copy of this message</mdb-checkbox>
                  <!-- Send button -->
                  <button mdbBtn color="info" outline="true" block="true" class="z-depth-0 my-4 waves-effect"
                    mdbWavesEffect type="submit" [disabled]="disabledSubmitButton">Send</button>
                </form>
                <!-- Default form contact -->
              
        
    
        
            
                import { ConnectionService } from './connection.service';
                import { FormGroup, FormBuilder, Validators } from '@angular/forms';
                import { Component, HostListener } from '@angular/core';

                @Component({
                  selector: 'app-root',
                  templateUrl: './app.component.html',
                  styleUrls: ['./app.component.scss'],
                })
                export class AppComponent {
                  contactForm: FormGroup;
                  disabledSubmitButton: boolean = true;

                  @HostListener('input') oninput() {
                    if (this.contactForm.valid) {
                      this.disabledSubmitButton = false;
                    }
                  }

                  constructor(private fb: FormBuilder, private connectionService: ConnectionService) {
                    this.contactForm = fb.group({
                      'contactFormName': ['', Validators.required],
                      'contactFormEmail': ['', Validators.compose([Validators.required, Validators.email])],
                      'contactFormSubjects': ['', Validators.required],
                      'contactFormMessage': ['', Validators.required],
                      'contactFormCopy': [''],
                    });
                  }

                  onSubmit() {
                    this.connectionService.sendMessage(this.contactForm.value).subscribe(() => {
                      alert('Your message has been sent.');
                      this.contactForm.reset();
                      this.disabledSubmitButton = true;
                    }, error => {
                      console.log('Error', error);
                    });
                  }
                }
              
        
    

Material form contact MDB Pro component

Contact us
Subject
        
            
                <mdb-card>
                  <mdb-card-header class="info-color white-text text-center py-4">
                    <h5>
                      <strong>Contact us</strong>
                    </h5>
                  </mdb-card-header>
                  <mdb-card-body class="px-lg-5 pt-0">
                  <form
                    class="text-center"
                    style="color: #757575;"
                    [formGroup]="contactForm"
                    (ngSubmit)="onSubmit()"
                  >
                    <div class="md-form mt-3">
                      <input
                        type="text"
                        formControlName="contactFormName"
                        id="materialContactFormName"
                        class="form-control"
                        mdbInput
                        mdbValidate
                      />
                      <label for="materialContactFormName">Name</label>
                      <mdb-error *ngIf="name.invalid && (name.dirty || name.touched)"
                        >Input invalid</mdb-error
                      >
                      <mdb-success *ngIf="name.valid && (name.dirty || name.touched)"
                        >Input valid</mdb-success
                      >
                    </div>
                    <div class="md-form">
                      <input
                        type="email"
                        formControlName="contactFormEmail"
                        id="materialContactFormEmail"
                        class="form-control"
                        mdbInput
                        mdbValidate
                      />
                      <label for="materialContactFormEmail">E-mail</label>
                      <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)"
                        >Input invalid</mdb-error
                      >
                      <mdb-success *ngIf="email.valid && (email.dirty || email.touched)"
                        >Input valid</mdb-success
                      >
                    </div>
                    <span>Subject</span>
                    <div class="row">
                      <div class="col-md-12 mx-auto">
                        <div class="md-form">
                          <mdb-select
                            formControlName="contactFormSubjects"
                            [options]="optionsSelect"
                            placeholder="Choose your option"
                            mdbValidate
                          ></mdb-select>
                          <mdb-error *ngIf="subjects.invalid && (subjects.dirty || subjects.touched)"
                            >Input invalid</mdb-error
                          >
                          <mdb-success *ngIf="subjects.valid && (subjects.dirty || subjects.touched)"
                            >Input valid</mdb-success
                          >
                        </div>
                      </div>
                    </div>
                    <div class="md-form">
                      <textarea
                        type="text"
                        formControlName="contactFormMessage"
                        id="materialContactFormMessage"
                        class="form-control md-textarea"
                        mdbInput
                        mdbValidate
                      ></textarea>
                      <label for="materialContactFormMessage">Message</label>
                      <mdb-error *ngIf="message.invalid && (message.dirty || message.touched)"
                        >Input invalid</mdb-error
                      >
                      <mdb-success *ngIf="message.valid && (message.dirty || message.touched)"
                        >Input valid</mdb-success
                      >
                    </div>
                    <div class="row">
                      <div class="col-md-6 mx-auto d-flex justify-content-center">
                        <div class="md-form">
                          <mdb-checkbox mdbValidate formControlName="contactFormCopy"
                            >Send me a copy of this message</mdb-checkbox
                          >
                          <mdb-error *ngIf="copy.invalid && (copy.dirty || copy.touched)"
                            >Input invalid</mdb-error
                          >
                          <mdb-success *ngIf="copy.valid && (copy.dirty || copy.touched)"
                            >Input valid</mdb-success
                          >
                        </div>
                      </div>
                    </div>
                    <button
                      mdbBtn
                      color="info"
                      outline="true"
                      rounded="true"
                      block="true"
                      class="z-depth-0 my-4 waves-effect"
                      mdbWavesEffect
                      type="submit"
                      [disabled]="disabledSubmitButton"
                    >
                      Send
                    </button>
                  </form>
                  </mdb-card-body>
                </mdb-card>
              
        
    
        
            
                import { ConnectionService } from './connection.service';
                import { FormGroup, FormBuilder, Validators } from '@angular/forms';
                import { Component, HostListener } from '@angular/core';

                @Component({
                  selector: 'app-root',
                  templateUrl: './app.component.html',
                  styleUrls: ['./app.component.scss'],
                })
                export class AppComponent {
                  contactForm: FormGroup;
                  disabledSubmitButton: boolean = true;

                  optionsSelect = [
                    { value: 'Feedback', label: 'Feedback' },
                    { value: 'Report a bug', label: 'Report a bug' },
                    { value: 'Feature request', label: 'Feature request' },
                    { value: 'Other stuff', label: 'Other stuff' },
                  ];

                  @HostListener('input') oninput() {
                    if (this.contactForm.valid) {
                      this.disabledSubmitButton = false;
                    }
                  }

                  constructor(fb: FormBuilder, private connectionService: ConnectionService) {
                    this.contactForm = fb.group({
                      'contactFormName': ['', Validators.required],
                      'contactFormEmail': ['', Validators.compose([Validators.required, Validators.email])],
                      'contactFormSubjects': ['', Validators.required],
                      'contactFormMessage': ['', Validators.required],
                      'contactFormCopy': ['', Validators.requiredTrue],
                    });
                  }

                  get name() {
                    return this.contactForm.get('contactFormName');
                  }

                  get email() {
                    return this.contactForm.get('contactFormEmail');
                  }

                  get subjects() {
                    return this.contactForm.get('contactFormSubjects');
                  }

                  get message() {
                    return this.contactForm.get('contactFormMessage');
                  }

                  get copy() {
                    return this.contactForm.get('contactFormCopy');
                  }

                  onSubmit() {
                    this.connectionService.sendMessage(this.contactForm.value).subscribe(() => {
                      alert('Your message has been sent.');
                      this.contactForm.reset();
                      this.disabledSubmitButton = true;
                    }, (error: any) => {
                      console.log('Error', error);
                    });
                  }
              }
              
        
    

After copying the above code to your application you will see a ready to use form. Let me briefly describe what exactly the above component code does.

In the constructor we define all fields of the form. All fields except contactFormCopy are marked as required, which means that without filling in these fields, we will not be able to send the form. This implements the client-side validation.

In the ngOnInit lifecycle, we populate the optionsSelect variable with values that will serve as message subjects that the user will be able to select in the form.

The onSubmit() method is responsible for calling the sendMessage() method defined in the ConnectionService service. This method is responsible for sending our form to the backend.


Building the ConnectionService logic

The ConnectionService is responsible for contact with our backend written in NodeJS. It is not yet created, but we will do it in the next step. Let's now fill in the ConnectionService with the appropriate code, which will allow you to send the form to the backend.

        
            
          import { HttpClient, HttpHeaders } from '@angular/common/http';
          import { Injectable } from '@angular/core';

          @Injectable({
            providedIn: 'root'
          })
          export class ConnectionService {
            url: string = 'http://localhost:3000/send';

            constructor(private http: HttpClient) {}

            sendMessage(messageContent: any) {
              return this.http.post(this.url,
              JSON.stringify(messageContent),
              { headers: new HttpHeaders({ 'Content-Type': 'application/json' }), responseType: 'text' });
            }
          }
        
        
    

The sendMessage() method is responsible for hitting the http://localhost:3000/send address, which is the router defined in the Express server that we will immediately create. Thanks to this, our application knows how to send data between the frontend and backend layers.

The post() method of the HttpClient class takes three parameters.

The first parameter is the address of the endpoint to be hit by the front layer.

The second parameter is the data that the front has to send to the address from the first parameter.

The third parameter details the options, which we can pass to the request. In them, we pass the Http header with the defined Content-Type parameter.


Creating the NodeJS backend server file

To do this, Create a new file in your application's root directory, and name it server.js, then paste the code you will find below. Without any worries, I'll immediately describe what the code you copy is doing.

If you haven't installed the express, nodemailer and body-parser packages from the npm repository so far, do so immediately using the following command in your application terminal:

        
            
          npm install express nodemailer body-parser --save
        
        
    
        
            
          const express = require('express');
          const nodemailer = require('nodemailer');
          const app = express();
          const port = 3000;
          const bodyParser = require('body-parser');

          const transporter = nodemailer.createTransport({
            host: 'smtp.gmail.com',
            provider: 'gmail',
            port: 465,
            secure: true,
            auth: {
              user: ' ', // Enter here email address from which you want to send emails
              pass: ' ' // Enter here password for email account from which you want to send emails
            },
            tls: {
            rejectUnauthorized: false
            }
          });

          app.use(bodyParser.json());

          app.use(function (req, res, next) {
            res.header("Access-Control-Allow-Origin", "*");
            res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
            next();
          });

          app.post('/send', function (req, res) {
            let senderName = req.body.contactFormName;
            let senderEmail = req.body.contactFormEmail;
            let messageSubject = req.body.contactFormSubjects;
            let messageText = req.body.contactFormMessage;
            let copyToSender = req.body.contactFormCopy;

            let mailOptions = {
              to: [' '], // Enter here the email address on which you want to send emails from your customers
              from: senderName,
              subject: messageSubject,
              text: messageText,
              replyTo: senderEmail
            };

            if (senderName === '') {
              res.status(400);
              res.send({
              message: 'Bad request'
              });
              return;
            }

            if (senderEmail === '') {
              res.status(400);
              res.send({
              message: 'Bad request'
              });
              return;
            }

            if (messageSubject === '') {
              res.status(400);
              res.send({
              message: 'Bad request'
              });
              return;
            }

            if (messageText === '') {
              res.status(400);
              res.send({
              message: 'Bad request'
              });
              return;
            }

            if (copyToSender) {
              mailOptions.to.push(senderEmail);
            }

            transporter.sendMail(mailOptions, function (error, response) {
              if (error) {
                console.log(error);
                res.end('error');
              } else {
                console.log('Message sent: ', response);
                res.end('sent');
              }
            });
          });

          app.listen(port, function () {
            console.log('Express started on port: ', port);
          });
        
        
    

I will start the description of the above code from the top.

Line 7 — const transporter = nodemailer.createTransport({ }) is used to create a function that takes the object containing the configuration of the transporter as a parameter. It is in this configuration that you define the host from which emails are sent, the provider (if it is gmail), port, authorization, and many other things that are to be sent. To make it easier, you can send emails from a Gmail account. To do this, enter your username and password to your mailbox in the user and pass keys.

Line 22 — app.use(bodyParser.json()); launches the body-parser, thanks to which we can intercept data sent in the requests from the frontend layer.

Lines 24 — 29 are only used in development environments. It is not recommended to use them in a production environment unless you know exactly what you are doing.

In line 31 we define route /post, after which the frontend layer sends data to the backend layer. This is where the actual email is sent to the mailbox.

Lines 33 — 37 create helper variables, thanks to which we can more easily refer to the individual components of our request.

Line 39 defines the mailOptions object that is sent to the sendMail() method. It is in this object that we define, to who the email is to be sent, from who, what is its subject, text, and to who the response in the email is to be addressed. In this object are many more options that you can use. You will find them all on this page.

Lines 47 - 77 are responsible for server-side validation. This is a very simple validation, which only checks if all of the required fields are given. If any of them is not given, the backend returns the message to the front layer that the request is incorrect.

Lines 79 - 81 correspond to whether a copy of the message should be sent to the user. In the form, this is determined by the checkbox.

Lines 83 - 89 are responsible for mail sending. This is where the sendMail() function with the parameters defined above is called. If an error occurs, the server console will register the log. If the shipment is successful, the whole message will be returned to the server console.

Lines 92 - 94 run our Express server on the port 3000, which we defined at the beginning of the file.


Tutorial conclusion

In this tutorial, I presented a very simple way to send messages from the contact form on the front, through the use of a very popular backend stack NodeJS + Express. The example application, which you wrote together with me, can be easily extended by, e.g. more advanced validation on the server side, and other, interesting things on the front end.

If you have any problems while working with this tutorial, please look at our support forum and see if anyone has already had a similar problem.

If you encountered a problem with Google blocking your application while sending an email from @gmail, try changing permissions for less secure applications. You can achieve this by visiting this page.

Angular Contact Form - API

In this section you will find informations about required modules of the Angular Contact Form.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

        
            
            import { WavesModule, ButtonsModule, CardsModule, InputsModule } from 'ng-uikit-pro-standard';
            import { FormsModule, ReactiveFormsModule } from '@angular/forms';
            import { HttpClientModule } from '@angular/common/http';
          
        
    
        
            
            import { WavesModule, ButtonsModule, CardsModule, InputsModule } from 'angular-bootstrap-md';
            import { FormsModule, ReactiveFormsModule } from '@angular/forms';
            import { HttpClientModule } from '@angular/common/http';